%bcond_with bootstrap

Summary:        Finite state machine compiler
Name:           ragel
Version:        7.0.4
Release:        2%{?dist}
License:        MIT and LGPLv2+
URL:            http://www.colm.net/open-source/%{name}/
Source0:        https://www.colm.net/files/%{name}/%{name}-%{version}.tar.gz
Patch0001:      https://github.com/adrian-thurston/ragel/commit/463f4914057b0193c6ca025e9233c17035bc0448.patch#/ragel-fallback-no-la.diff
Patch3000:      ragel-use-libdir.diff

BuildRequires:  make gcc gcc-c++
BuildRequires:  autoconf automake libtool
%if %{with bootstrap}
BuildRequires:  kelbt ragel
%endif
BuildRequires:  colm-devel = 0.14.7
# upstream doesn't exist and not possible to find version
Provides:       bundled(aapl)

%description
Ragel compiles executable finite state machines from regular languages. It targets C, C++ and 
ASM. Ragel state machines can not only recognize byte sequences as regular expression machines 
do, but can also execute code at arbitrary points in the recognition of a regular language. 
Code embedding is done using inline operators that do not disrupt the regular language syntax.

%prep
%autosetup
# not pollute with docs
sed -i -e "/dist_doc_DATA/d" Makefile.am

%build
autoreconf -fiv
%configure --disable-static --with-colm=%{_prefix} --disable-manual
%make_build

%install
%make_install
find %{buildroot}%{_libdir} -type f -name '*.la' -print -delete
install -p -m 0644 -D %{name}.vim %{buildroot}%{_datadir}/vim/vimfiles/syntax/%{name}.vim

%files
%license COPYING
%{_bindir}/%{name}
%{_bindir}/%{name}-*
%exclude %{_libdir}/libragel.so
%{_libdir}/libragel.so.*
%{_datarootdir}/%{name}.lm
%{_datarootdir}/out-go.lm
%dir %{_datadir}/vim
%dir %{_datadir}/vim/vimfiles
%dir %{_datadir}/vim/vimfiles/syntax
%{_datadir}/vim/vimfiles/syntax/%{name}.vim
%{_mandir}/man1/%{name}.1*

%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 7.0.4-2
- Rebuilt for loongarch release

* Fri Oct 27 2023 Wang Guodong <gordonwwang@tencent.com> - 7.0.4-1
- initial build
